diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/wifi-tx-vector.h ns-3.39/src/wifi/model/wifi-tx-vector.h
--- ns-3.38/src/wifi/model/wifi-tx-vector.h	2023-03-16 20:54:23.868869300 -0700
+++ ns-3.39/src/wifi/model/wifi-tx-vector.h	2023-07-05 14:23:48.125428400 -0700
@@ -27,11 +27,15 @@
 #include "ns3/he-ru.h"
 
 #include <list>
+#include <optional>
 #include <vector>
 
 namespace ns3
 {
 
+/// STA_ID for a RU that is intended for no user (Section 26.11.1 802.11ax-2021)
+static constexpr uint16_t NO_USER_STA_ID = 2046;
+
 /// HE MU specific user transmission parameters.
 struct HeMuUserInfo
 {
@@ -55,19 +59,23 @@
     bool operator!=(const HeMuUserInfo& other) const;
 };
 
-/// A vector of subcarrier group
-using SubcarrierGroups = std::vector<HeRu::SubcarrierGroup>;
-
-/// Maximum number of HE-SIG-B content channels
-constexpr size_t WIFI_MAX_NUM_HE_SIGB_CONTENT_CHANNELS = 2;
-
-/// HE SIG-B Content Channels STA ID Allocation
-using ContentChannelAllocation = std::vector<std::vector<uint16_t>>;
-
 /// 8 bit RU_ALLOCATION per 20 MHz
 using RuAllocation = std::vector<uint8_t>;
 
 /**
+ * \ingroup wifi
+ * Enum for the different values for CENTER_26_TONE_RU
+ */
+enum Center26ToneRuIndication : uint8_t
+{
+    CENTER_26_TONE_RU_UNALLOCATED = 0,
+    CENTER_26_TONE_RU_LOW_80_MHZ_ALLOCATED,          /* also used if BW == 80 MHz */
+    CENTER_26_TONE_RU_HIGH_80_MHZ_ALLOCATED,         /* unused if BW < 160 MHz */
+    CENTER_26_TONE_RU_LOW_AND_HIGH_80_MHZ_ALLOCATED, /* unused if BW < 160 MHz */
+    CENTER_26_TONE_RU_INDICATION_MAX                 /* last value */
+};
+
+/**
  * This class mimics the TXVECTOR which is to be
  * passed to the PHY in order to define the parameters which are to be
  * used for a transmission. See IEEE 802.11-2016 16.2.5 "Transmit PHY",
@@ -363,6 +371,12 @@
      */
     bool IsUlMu() const;
     /**
+     * Check if STA ID is allocated
+     * \param staId STA ID
+     * \return true if allocated, false otherwise
+     */
+    bool IsAllocated(uint16_t staId) const;
+    /**
      * Get the RU specification for the STA-ID.
      * This is applicable only for MU.
      *
@@ -408,15 +422,17 @@
      * \return a reference to the map of HE MU user-specific information indexed by STA-ID
      */
     HeMuUserInfoMap& GetHeMuUserInfoMap();
+
+    /// map of specific user info parameters ordered per increasing frequency RUs
+    using UserInfoMapOrderedByRus = std::map<HeRu::RuSpec, uint16_t, HeRu::RuSpecCompare>;
+
     /**
-     * Get the number of RUs per HE-SIG-B content channel.
-     * This is applicable only for MU. MU-MIMO (i.e. multiple stations
-     * per RU) is not supported yet.
-     * See section 27.3.10.8.3 of IEEE 802.11ax draft 4.0.
+     * Get the map of specific user info parameters ordered per increasing frequency RUs.
      *
-     * \return a pair containing the number of RUs in each HE-SIG-B content channel (resp. 1 and 2)
+     * \param p20Index the index of the primary20 channel
+     * \return the map of specific user info parameters ordered per increasing frequency RUs
      */
-    std::pair<std::size_t, std::size_t> GetNumRusPerHeSigBContentChannel() const;
+    UserInfoMapOrderedByRus GetUserInfoMapOrderedByRus(uint8_t p20Index) const;
 
     /**
      * Set the 20 MHz subchannels that are punctured.
@@ -448,23 +464,32 @@
     WifiMode GetSigBMode() const;
 
     /**
-     * Set RU Allocation of SIG-B common field
+     * Set RU_ALLOCATION field
      * \param ruAlloc 8 bit RU_ALLOCATION per 20 MHz
+     * \param p20Index the index of the primary20 channel
      */
-    void SetRuAllocation(const RuAllocation& ruAlloc);
+    void SetRuAllocation(const RuAllocation& ruAlloc, uint8_t p20Index);
 
     /**
-     * Get RU Allocation of SIG-B
+     * Get RU_ALLOCATION field
      * \return 8 bit RU_ALLOCATION per 20 MHz
+     * \param p20Index the index of the primary20 channel
+     */
+    const RuAllocation& GetRuAllocation(uint8_t p20Index) const;
+
+    /**
+     * Set CENTER_26_TONE_RU field
+     * \param center26ToneRuIndication the CENTER_26_TONE_RU field
      */
-    const RuAllocation& GetRuAllocation() const;
+    void SetCenter26ToneRuIndication(Center26ToneRuIndication center26ToneRuIndication);
 
     /**
-     * Get the HE SIG-B content channel STA ID allocation
-     * IEEE 802.11ax-2021 27.3.11.8.2 HE-SIG-B content channels
-     * \return content channel allocation
+     * Get CENTER_26_TONE_RU field
+     * This field is present if format is HE_MU and
+     * when channel width is set to 80 MHz or larger.
+     * \return the CENTER_26_TONE_RU field if present
      */
-    ContentChannelAllocation GetContentChannelAllocation() const;
+    std::optional<Center26ToneRuIndication> GetCenter26ToneRuIndication() const;
 
     /**
      * Set the EHT_PPDU_TYPE parameter
@@ -479,12 +504,24 @@
 
   private:
     /**
-     * Derive the RU allocation from the TXVECTOR for which its RU allocation has not been set yet.
-     * This is valid only for allocations of RUs of the same size.
+     * Derive the RU_ALLOCATION field from the TXVECTOR
+     * for which its RU_ALLOCATION field has not been set yet,
+     * based on the content of per-user information.
+     * This is valid only for allocations of RUs of the same size per 20 MHz subchannel.
      *
-     * \return the RU allocation
+     * \param p20Index the index of the primary20 channel
+     * \return 8 bit RU_ALLOCATION per 20 MHz
      */
-    RuAllocation DeriveRuAllocation() const;
+    RuAllocation DeriveRuAllocation(uint8_t p20Index) const;
+
+    /**
+     * Derive the CENTER_26_TONE_RU field from the TXVECTOR
+     * for which its CENTER_26_TONE_RU has not been set yet,
+     * based on the content of per-user information.
+     *
+     * \return the CENTER_26_TONE_RU field
+     */
+    Center26ToneRuIndication DeriveCenter26ToneRuIndication() const;
 
     WifiMode m_mode;          /**< The DATARATE parameter in Table 15-4.
                               It is the value that will be passed
@@ -519,7 +556,13 @@
 
     mutable RuAllocation m_ruAllocation; /**< RU allocations that are going to be carried
                                               in SIG-B common field per Table 27-1 IEEE */
-    uint8_t m_ehtPpduType;               /**< EHT_PPDU_TYPE per Table 36-1 IEEE 802.11be D2.3 */
+
+    mutable std::optional<Center26ToneRuIndication>
+        m_center26ToneRuIndication; /**< CENTER_26_TONE_RU field when format is HE_MU and
+                                         when channel width is set to 80 MHz or larger  (Table 27-1
+                                       802.11ax-2021)*/
+
+    uint8_t m_ehtPpduType; /**< EHT_PPDU_TYPE per Table 36-1 IEEE 802.11be D2.3 */
 };
 
 /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/yans-error-rate-model.cc ns-3.39/src/wifi/model/yans-error-rate-model.cc
--- ns-3.38/src/wifi/model/yans-error-rate-model.cc	2023-03-16 20:54:23.868869300 -0700
+++ ns-3.39/src/wifi/model/yans-error-rate-model.cc	2023-07-05 14:23:48.125428400 -0700
@@ -206,7 +206,7 @@
     if (mode.GetModulationClass() >= WIFI_MOD_CLASS_ERP_OFDM)
     {
         uint64_t phyRate;
-        if ((txVector.IsMu() && (staId == SU_STA_ID)) || (mode != txVector.GetMode()))
+        if ((txVector.IsMu() && (staId == SU_STA_ID)) || (mode != txVector.GetMode(staId)))
         {
             phyRate = mode.GetPhyRate(txVector.GetChannelWidth() >= 40
                                           ? 20
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/yans-wifi-channel.cc ns-3.39/src/wifi/model/yans-wifi-channel.cc
--- ns-3.38/src/wifi/model/yans-wifi-channel.cc	2023-03-16 20:54:23.868869300 -0700
+++ ns-3.39/src/wifi/model/yans-wifi-channel.cc	2023-07-05 14:23:48.125428400 -0700
@@ -145,7 +145,7 @@
     }
     RxPowerWattPerChannelBand rxPowerW;
     rxPowerW.insert(
-        {std::make_pair(0, 0), (DbmToW(rxPowerDbm + phy->GetRxGain()))}); // dummy band for YANS
+        {{{0, 0}, {0, 0}}, (DbmToW(rxPowerDbm + phy->GetRxGain()))}); // dummy band for YANS
     phy->StartReceivePreamble(ppdu, rxPowerW, ppdu->GetTxDuration());
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/yans-wifi-phy.cc ns-3.39/src/wifi/model/yans-wifi-phy.cc
--- ns-3.38/src/wifi/model/yans-wifi-phy.cc	2023-03-16 20:54:23.868869300 -0700
+++ ns-3.39/src/wifi/model/yans-wifi-phy.cc	2023-07-05 14:23:48.125428400 -0700
@@ -53,10 +53,7 @@
 {
     WifiPhy::SetInterferenceHelper(helper);
     // add dummy band for Yans
-    WifiSpectrumBand band;
-    band.first = 0;
-    band.second = 0;
-    m_interference->AddBand(band);
+    m_interference->AddBand({{0, 0}, {0, 0}});
 }
 
 YansWifiPhy::~YansWifiPhy()
@@ -109,4 +106,22 @@
     return std::make_tuple(0.0, 0.0, 0.0);
 }
 
+WifiSpectrumBandInfo
+YansWifiPhy::GetBand(uint16_t /*bandWidth*/, uint8_t /*bandIndex*/)
+{
+    return {{0, 0}, {0, 0}};
+}
+
+FrequencyRange
+YansWifiPhy::GetCurrentFrequencyRange() const
+{
+    return WHOLE_WIFI_SPECTRUM;
+}
+
+WifiSpectrumBandFrequencies
+YansWifiPhy::ConvertIndicesToFrequencies(const WifiSpectrumBandIndices& /*indices*/) const
+{
+    return {0, 0};
+}
+
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/yans-wifi-phy.h ns-3.39/src/wifi/model/yans-wifi-phy.h
--- ns-3.38/src/wifi/model/yans-wifi-phy.h	2023-03-16 20:54:23.868869300 -0700
+++ ns-3.39/src/wifi/model/yans-wifi-phy.h	2023-07-05 14:23:48.125428400 -0700
@@ -61,6 +61,10 @@
     Ptr<Channel> GetChannel() const override;
     uint16_t GetGuardBandwidth(uint16_t currentChannelWidth) const override;
     std::tuple<double, double, double> GetTxMaskRejectionParams() const override;
+    WifiSpectrumBandInfo GetBand(uint16_t bandWidth, uint8_t bandIndex = 0) override;
+    FrequencyRange GetCurrentFrequencyRange() const override;
+    WifiSpectrumBandFrequencies ConvertIndicesToFrequencies(
+        const WifiSpectrumBandIndices& indices) const override;
 
     /**
      * Set the YansWifiChannel this YansWifiPhy is to be connected to.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/test/80211b.c ns-3.39/src/wifi/test/80211b.c
--- ns-3.38/src/wifi/test/80211b.c	2023-03-16 20:54:23.868869300 -0700
+++ ns-3.39/src/wifi/test/80211b.c	2023-07-05 14:23:48.125428400 -0700
@@ -1,4 +1,3 @@
-/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
 /*
  * Copyright (c) 2010 The Boeing Company
  *
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/test/channel-access-manager-test.cc ns-3.39/src/wifi/test/channel-access-manager-test.cc
--- ns-3.38/src/wifi/test/channel-access-manager-test.cc	2023-03-16 20:54:23.868869300 -0700
+++ ns-3.39/src/wifi/test/channel-access-manager-test.cc	2023-07-05 14:23:48.125428400 -0700
@@ -20,6 +20,8 @@
 #include "ns3/adhoc-wifi-mac.h"
 #include "ns3/channel-access-manager.h"
 #include "ns3/frame-exchange-manager.h"
+#include "ns3/interference-helper.h"
+#include "ns3/multi-model-spectrum-channel.h"
 #include "ns3/qos-txop.h"
 #include "ns3/simulator.h"
 #include "ns3/spectrum-wifi-phy.h"
@@ -84,7 +86,8 @@
         uint64_t at;     //!< at
         uint32_t nSlots; //!< number of slots
     };
-    typedef std::list<struct ExpectedBackoff> ExpectedBackoffs; //!< expected backoffs typedef
+
+    typedef std::list<ExpectedBackoff> ExpectedBackoffs; //!< expected backoffs typedef
 
     ExpectedBackoffs m_expectedInternalCollision; //!< expected backoff due to an internal collision
     ExpectedBackoffs m_expectedBackoff; //!< expected backoff (not due to an internal collision)
@@ -409,7 +412,7 @@
 
     Ptr<FrameExchangeManagerStub<TxopType>> m_feManager;  //!< the Frame Exchange Manager stubbed
     Ptr<ChannelAccessManagerStub> m_ChannelAccessManager; //!< the channel access manager
-    Ptr<WifiPhy> m_phy;                                   //!< the PHY object
+    Ptr<SpectrumWifiPhy> m_phy;                           //!< the PHY object
     TxopTests m_txop;                                     //!< the vector of Txop test instances
     uint32_t m_ackTimeoutValue;                           //!< the Ack timeout value
 };
@@ -620,6 +623,8 @@
     // SetupPhyListener(), requires an attached PHY to determine the channel types
     // to initialize
     m_phy = CreateObject<SpectrumWifiPhy>();
+    m_phy->SetInterferenceHelper(CreateObject<InterferenceHelper>());
+    m_phy->AddChannel(CreateObject<MultiModelSpectrumChannel>());
     m_phy->SetOperatingChannel(WifiPhy::ChannelTuple{0, chWidth, WIFI_PHY_BAND_UNSPECIFIED, 0});
     m_phy->ConfigureStandard(WIFI_STANDARD_80211ac); // required to use 160 MHz channels
     m_ChannelAccessManager->SetupPhyListener(m_phy);
@@ -1342,7 +1347,7 @@
     void RunOne(uint16_t chWidth, WifiChannelListType busyChannel);
 
     Ptr<ChannelAccessManager> m_cam; //!< channel access manager
-    Ptr<WifiPhy> m_phy;              //!< PHY object
+    Ptr<SpectrumWifiPhy> m_phy;      //!< PHY object
 };
 
 LargestIdlePrimaryChannelTest::LargestIdlePrimaryChannelTest()
@@ -1436,9 +1441,9 @@
 
     // At RX end, we check the status of the channel during the interval following
     // the CCA_BUSY period and preceding RX start. The entire operating channel is idle.
-    Time checkTime4 = checkTime3;
+    const Time& checkTime4 = checkTime3;
     Simulator::Schedule(checkTime4 - start, [=]() {
-        Time interval4 = ccaBusyRxInterval;
+        const Time& interval4 = ccaBusyRxInterval;
         Time end4 = checkTime4 - rxDuration;
         NS_TEST_EXPECT_MSG_EQ(m_cam->GetLargestIdlePrimaryChannel(interval4, end4),
                               chWidth,
@@ -1461,7 +1466,7 @@
     });
 
     // After RX end, no channel is idle if the interval overlaps the RX period
-    Time checkTime6 = checkTime5;
+    const Time& checkTime6 = checkTime5;
     Simulator::Schedule(checkTime6 - start, [=]() {
         Time interval6 = interval5 + rxDuration / 2;
         NS_TEST_EXPECT_MSG_EQ(m_cam->GetLargestIdlePrimaryChannel(interval6, checkTime6),
@@ -1495,6 +1500,8 @@
                 }
                 // create a new PHY operating on a channel of the current width
                 m_phy = CreateObject<SpectrumWifiPhy>();
+                m_phy->SetInterferenceHelper(CreateObject<InterferenceHelper>());
+                m_phy->AddChannel(CreateObject<MultiModelSpectrumChannel>());
                 m_phy->SetOperatingChannel(
                     WifiPhy::ChannelTuple{0, chWidth, WIFI_PHY_BAND_5GHZ, 0});
                 m_phy->ConfigureStandard(WIFI_STANDARD_80211ax);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/test/examples-to-run.py ns-3.39/src/wifi/test/examples-to-run.py
--- ns-3.38/src/wifi/test/examples-to-run.py	2023-03-16 20:54:23.872869300 -0700
+++ ns-3.39/src/wifi/test/examples-to-run.py	2023-07-05 14:23:48.125428400 -0700
@@ -1,5 +1,4 @@
 #! /usr/bin/env python3
-## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-
 
 # A list of C++ examples to run in order to ensure that they remain
 # buildable and runnable over time.  Each tuple in the list contains
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/test/inter-bss-test-suite.cc ns-3.39/src/wifi/test/inter-bss-test-suite.cc
--- ns-3.38/src/wifi/test/inter-bss-test-suite.cc	2023-03-16 20:54:23.872869300 -0700
+++ ns-3.39/src/wifi/test/inter-bss-test-suite.cc	2023-07-05 14:23:48.125428400 -0700
@@ -77,7 +77,12 @@
 class TestInterBssConstantObssPdAlgo : public TestCase
 {
   public:
-    TestInterBssConstantObssPdAlgo();
+    /**
+     * Constructor
+     *
+     * \param standard The standard to use for the test
+     */
+    TestInterBssConstantObssPdAlgo(WifiStandard standard);
     ~TestInterBssConstantObssPdAlgo() override;
 
     void DoRun() override;
@@ -205,9 +210,11 @@
     uint8_t m_bssColor1; ///< color for BSS 1
     uint8_t m_bssColor2; ///< color for BSS 2
     uint8_t m_bssColor3; ///< color for BSS 3
+
+    WifiStandard m_standard; ///< the standard to use for the test
 };
 
-TestInterBssConstantObssPdAlgo::TestInterBssConstantObssPdAlgo()
+TestInterBssConstantObssPdAlgo::TestInterBssConstantObssPdAlgo(WifiStandard standard)
     : TestCase("InterBssConstantObssPd"),
       m_numSta1PacketsSent(0),
       m_numSta2PacketsSent(0),
@@ -226,7 +233,8 @@
       m_expectedTxPowerDbm(15),
       m_bssColor1(1),
       m_bssColor2(2),
-      m_bssColor3(3)
+      m_bssColor3(3),
+      m_standard(standard)
 {
 }
 
@@ -850,7 +858,7 @@
     phy.Set("ChannelSettings", StringValue("{36, 20, BAND_5GHZ, 0}"));
 
     WifiHelper wifi;
-    wifi.SetStandard(WIFI_STANDARD_80211ax);
+    wifi.SetStandard(m_standard);
     wifi.SetRemoteStationManager("ns3::ConstantRateWifiManager",
                                  "DataMode",
                                  StringValue("HeMcs5"),
@@ -991,7 +999,8 @@
 InterBssTestSuite::InterBssTestSuite()
     : TestSuite("wifi-inter-bss", UNIT)
 {
-    AddTestCase(new TestInterBssConstantObssPdAlgo, TestCase::QUICK);
+    AddTestCase(new TestInterBssConstantObssPdAlgo(WIFI_STANDARD_80211ax), TestCase::QUICK);
+    AddTestCase(new TestInterBssConstantObssPdAlgo(WIFI_STANDARD_80211be), TestCase::QUICK);
 }
 
 // Do not forget to allocate an instance of this TestSuite
